Quickstart
==========

Full tutorial [here](https://www.meteor.com/try).

To create a meteor app type:

    $ meteor create appname

This will create a directory called `appname` in your current working directory.

To run your app, `cd` into `appname` and type:
 
    $ cd appname/
    $ meteor

Now the webserver is running on port 3000 on your local box. Open your browser and go to [localhost:3000](http://localhost:3000).

Security
========
User accounts need to be added using:

    // To add support for user accounts
    meteor add accounts-ui accounts-password

    // Moves DB on server and prevents client from modifying
    // DB directly. Must have Meteor "methods" defined.
    meteor remove insecure

    // Filters out the data that can be sent to a client
    // TODO: understand how this works exactly
    meteor remove autopublish

Misc
====

    // Deploys webapp online
    meteor deploy friendme.meteor.com

    // Test on Android emulator
    meteor install-sdk android
    meteor add-platform android
    meteor run android

Docs
====
    
Look at sample applications:

    meteor create --example todos
    meteor create --example localmarket

There also a lot of books:

 * [Discover Meteor book](https://book.discovermeteor.com/starter)
 * [Design of the Meteor platform](https://www.meteor.com/projects)
 * [Documentation](https://docs.meteor.com/#/basic/)

Command line tool
=================
The meteor command line tool can use your meteor.com account

See:
    
    meteor whoami
    meteor login
    meteor logout

The `meteor deploy` command will ask you for credentials if you are not logged in and need to be.
