Template.addfriend.events({
  'click .addFriend': function (event, template) {
    event.preventDefault();

    var theirUsername = template.data.username;
    var theirFp = template.data.fp;
    // true if the user is accepting a friend request on this page, 
    // false if the user is initiating a friend request on this page
    var isAccept = template.data.isAccept;
    var date = template.data.date;
    // SIG_theirUsernameSK('friendRequest|theirUsername|myUsername|date')
    var reqSig = template.data.reqSig; 

    // NOTE: you can access the data context that you set in the IronRouter call
    // using:
    //  - this.fp
    //  - this.username
    // or:
    //  - template.data.fp
    //  - template.data.username

    //console.log('username: ' + theirUsername + ', fp: ' + theirFp);

    var theirPubKeyStr = Utils.getPublicKeyByUsername(theirUsername);
    //console.log('pubkey: ' + theirPubKeyStr);
   
    // NOTE: tested this path!
    if(CryptoUtils.verifyFingerprint(theirPubKeyStr, theirFp) == false) {
      template.find('#error').textContent = 'ERROR: ' + theirUsername + '\'s fingerprint does not match the public key returned by the server. Something is fishy.'; 
      return;
    }
    
    // We do not cache their pubkey, since we can get it pretty fast from Mongo
    var theirPubKey = CryptoUtils.unserializePublicKey(theirPubKeyStr);

    if(isAccept)
      Friends.acceptFriend(Utils.me(), Trustore.Keys.getAsymPrivate(), theirUsername, theirPubKey, date, reqSig);
    else
      Friends.addFriend(Utils.me(), Trustore.Keys.getAsymPrivate(), theirUsername, theirPubKey);

    // WARNING: Router.go() will not redirect unless you do event.preventDefault() at the top
    Router.go('/friends');
  },
});
