Template.album.helpers({
  whose: function() {
    if(!Meteor.user())
      return 'nobody';

    var owner = this.owner;

    if(Utils.me() == owner)
      return 'Your';
    else
      return owner + '\'s';
  },
});

Template.album.events({
  'submit .create-photo': function(event, template) {
    event.preventDefault();

    if (this.objid != null) {
      var me = Utils.me();
      var myMasterKey = Trustore.Keys.get('master');
      var myPrivateKey = Trustore.Keys.getAsymPrivate();
      var albumid = this.objid;

      var postElem = template.find('#post');
      var file = postElem.files[0];

      console.log("ADDING PHOTO: ADDER=" + me + ", ALBUM ID=" + albumid);

      var reader = new FileReader();
      reader.onloadend = function() {
        var origURL = reader.result;
        var orig = new Image();
        orig.onload = function() {
          var MAX_WIDTH = 200;
          var MAX_HEIGHT = 150;
          var thumbW = orig.width;
          var thumbH = orig.height;
          if (thumbW > thumbH) {
            if (thumbW > MAX_WIDTH) {
              thumbH *= MAX_WIDTH / thumbW;
              thumbW = MAX_WIDTH;
            }
          } else {
            if (thumbH > MAX_HEIGHT) {
              thumbW *= MAX_HEIGHT / thumbH;
              thumbH = MAX_HEIGHT;
            }
          }

          var thumbCV = document.createElement('canvas');
          thumbCV.width = thumbW;
          thumbCV.height = thumbH;
          var thumbCTX = thumbCV.getContext("2d");
          thumbCTX.drawImage(orig, 0, 0, thumbW, thumbH);
          var thumbURL = thumbCV.toDataURL("image/jpeg");

          /*
          var img = document.createElement("img");
          img.src = thumbURL;

          var src = document.body;
          src.appendChild(img);
          */
          
          // TESTESTEST
          // console.log(origURL);
          // console.log(thumbURL);

          Album.insertPhoto(albumid, me, myMasterKey, myPrivateKey, origURL, thumbURL);
          //console.log("ADDED PHOTO RAW BASE64: " + reader.result);
        }
        orig.src = origURL;
      }

      if(file) {
        reader.readAsDataURL(file);
        
        postElem.value = '';
      } else {
        console.log('ERROR: Must submit a file.');
      }
    } else {
      console.log('ERROR: Must have object id of album to add photo.');
    }
  },

  'click .delete-photo': function(event, template) {
    event.preventDefault();
    
    if(this.objid != null) {
      var me = Utils.me();
      var myMasterKey = Trustore.Keys.get('master');
      var myPrivateKey = Trustore.Keys.getAsymPrivate();
      var photoid = this.objid;
      var albumid = this.albumId;

      console.log("DELETING PHOTO: DELETER=" + me + ", PHOTO ID=" + photoid);
      try {
        Album.deletePhoto(albumid, me, myMasterKey, myPrivateKey, photoid);
      } catch (err) {
	console.log("ERROR: Do not have permission to delete this photo.");
      }
    } else {
      console.log('ERROR: Must have object id of photo to delete.');
    }
  },
});
