Template.albums.helpers({
  whose: function() {
    if(!Meteor.user())
      return 'nobody';

    var owner = this.owner;

    if(Utils.me() == owner)
      return 'Your';
    else
      return owner + '\'s';
  },
});

Template.albums.events({
  'submit .create-album': function(event, template) {
    event.preventDefault();

    var me = Utils.me();
    var myMasterKey = Trustore.Keys.get('master');
    var myPrivateKey = Trustore.Keys.getAsymPrivate();

    var postElem = template.find('#post');
    var post = postElem.value;
    console.log("ADDING ALBUM: ADDER=" + me + ", ALBUM NAME=" + post);

    if(post) {
      Album.createAlbum(me, myMasterKey, myPrivateKey, post);

      postElem.value = '';
    } else {
      console.log('ERROR: Must submit a file.');
    }
  },

  'click .delete-album': function(event, template) {
    event.preventDefault();
    
    if(this.objid != null) {
      var me = Utils.me();
      var myMasterKey = Trustore.Keys.get('master');
      var myPrivateKey = Trustore.Keys.getAsymPrivate();
      var albumid = this.objid;

      console.log("DELETING ALBUM: DELETER=" + me + ", ALBUM ID=" + albumid);
      try {
        Album.deleteAlbum(albumid, me);
      } catch (err) {
	console.log("ERROR: Do not have permission to delete this album.");
      }
    } else {
      console.log('ERROR: Must have object id of album to delete.');
    }
  },

});
