Template.viewConvo.helpers({
  quacks: function() {
    if(!Meteor.user())
      return [];

    var quacks = [];

    //console.log('lastquack: ' + stri(this.lastQuack));
    //console.log('content keys: ' + stri(this.contentKeys));

    quacks = this.convo.getQuacks(Utils.me(), this.myMasterKey, this.contentKeys, this.lastQuack, this.trustedLastQuackHash);
  
    //console.log('quacks: ' + quacks);
  
    return quacks.reverse();
  },
});

Template.viewConvo.events({
  'click .delete-member': function(event, template) {
    event.preventDefault();

    var convo = template.data.convo;
    assert(convo.data.owner == Utils.me());

    var username = event.target.id.slice('remove-'.length);
    var ownerMasterKey = template.data.myMasterKey;
    var ownerPrivateKey = Trustore.Keys.getAsymPrivate();
    var trustedAclHash = template.data.aclHash;

    //console.log('convo: ' + stri(convo));
    console.log('removing: ' + username);

    window.confirm('Are you sure you want to remove ' + username + ' from this conversation?');

    template.data.members = template.data.members.filter(function(u) { return u != username; });
    trustedAclHash = convo.removeUser(ownerMasterKey, ownerPrivateKey, username, trustedAclHash);
    template.data.aclHash = trustedAclHash;

    // NOTE: Had to try a bunch of stuff to avoid the Iron routing code from being rerun with
    // the old hash and failing verification, ultimately this worked.
    Router.current().params.query.hash = trustedAclHash;
    //Router.current().params.query = 'id=' + convo.data._id + '&hash=' + trustedAclHash;
    Router.go('/conversation?' + 'id=' + convo.data._id + '&hash=' + trustedAclHash);
    //Router.go('/conversations');
  },

  'submit .send-message': function(event, template) {
    event.preventDefault();

    var msgElem = template.find('#message');
    var post = msgElem.value;
    //console.log('Message: \'' + post + '\'');

    if(post) {
      // FIXME: any concurrency issues that might arise here
      var me = Utils.me();
          
      // If there's no lastQuack, then use the conversation as the prev quack
      if(!this.lastQuack) {
        this.lastQuack = this.convo;
      } else {
        // ACL version check here
        if(this.aclVer < this.lastQuack.data.aclVer) {
          throw new Meteor.Error('bad-acl-ver', 'Server is presenting mismatching views.'
            + ' Convo ACL has ver. ' + this.aclVer + ' but last quack has ACL ver. ' 
            + this.lastQuack.data.aclVer);
        }
      }
       
      var quack = Quack.create('message', me, this.aclVer, post, this.lastQuack);
      this.convo.addQuack(quack, this.contentKeys[this.aclVer - 1], Trustore.Keys.getAsymPrivate());

      msgElem.value = '';
    } else {
      console.log('Write something!');
    }
  },
});
