Template.dashboard.events({
  'click .logout': function (event) {
    event.preventDefault();
    Trustore.Keys.clear();
    // FIXME: we have to clear these because we don't have a good way of updating them
    // and code will rely on deprecated hashes and fail
    Trustore.Hashes.clear();  
    Meteor.logout(function () {
      Router.go('/login');
    });

    // FIXME: right now the '/' page is rendered immediately after
    // logout which calls the helpers defined in profile.js and
    // dashboard.js which throws a null pointer exception because
    // Meteor.user() is null. not sure how to make Meteor understand
    // the '/' should not be re-rendered. it should already know that
    // there's an onbeforeaction set that should be rendered first.
    // maybe we can fix this by having a separate /logout page.
  }
});

Template.dashboard.helpers({
  username: function() {
    if(!Meteor.user())
      return Utils.notLoggedInErrorMsg;

    // Note: this only returns the userData published by the server
    return Meteor.user().username;
    //return EJSON.stringify(Meteor.users.findOne(Meteor.userId));
  },
  pubkeyFingerprint: function() {
    if(!Meteor.user())
      return Utils.notLoggedInErrorMsg;

    return CryptoUtils.getPublicKeyFingerprint(Trustore.Keys.getAsymPrivate());
  }
});
