Template.wall.helpers({
  whose: function() {
    if(!Meteor.user())
      return 'nobody';

    var owner = this.owner;

    if(Utils.me() == owner)
      return 'Your';
    else
      return owner + '\'s';
  },

  quacks: function() {
    if(!Meteor.user())
      return [];
   
    return this.wall.getQuacks(Utils.me(), this.myMasterKey, this.contentKeys, this.lastQuack, 
      this.trustedLastQuackHash);
  },

  writeHint: function() {
    if(!Meteor.user())
      return 'Nothing.';

    if(Utils.me() == this.owner) {
      return 'What\'s on your mind? Share it with your friends...';
    } else {
      return 'Write something on ' + this.owner + '\'s wall';
    }
  },
});

Template.wall.events({
  'submit .write-wall-post': function(event, template) {
    event.preventDefault();

    var postElem = template.find('#post');
    var post = postElem.value;
    //console.log('Post: \'' + post + '\'');

    if(post) {
      // FIXME: any concurrency issues that might arise here
      var me = Utils.me();
      //var lastHash = Trustore.Hashes.get(this.dialogueId, me);
      
      // If there's no lastQuack, then use the wall as the prev quack
      if(!this.lastQuack) {
        //console.log('Using wall as the last quack: ' + stri(this.wall));
        this.lastQuack = this.wall;
      } else {
        // ACL version check here
        if(this.aclVer < this.lastQuack.data.aclVer) {
          throw new Meteor.Error('bad-acl-ver', 'Server is presenting mismatching views.'
            + ' Wall ACL has ver. ' + this.aclVer + ' but last quack has ACL ver. ' 
            + this.lastQuack.data.aclVer);
        }
      }
      
      var quack = Quack.create('wallpost', me, this.aclVer, post, this.lastQuack);
      this.wall.addQuack(quack, this.contentKeys[this.aclVer - 1], Trustore.Keys.getAsymPrivate());

      postElem.value = '';
    } else {
      console.log('ERROR: Must write a non-empty message first');
    }
  }
});
