// NOTE: this variable only has file scope due to the 'var' in front of it apparently.
// This is what we want too. See http://docs.meteor.com/#/full/namespacing for more details.
var allAccessPerms = {
  insert: function () { return true; },
  update: function () { return true; },
  remove: function () { return true; }, // I guess we might need to remove a tree when an object is deleted.
  // not sure if we'll need to set 'fetch:' here at all
}

var userProfilePerms = {
    insert: function(userId, doc) {
        return (doc.username === Utils.getUserName(userId));
    },

    update: function(userId, doc, fieldNames, modifier) {
        return (doc.username === Utils.getUserName(userId));
    },

    remove: function(userId, doc) {
        return (doc.username === Utils.getUserName(userId));
    }
};

var albumPerms = {
    insert: function(userId, doc) {
        return (doc.owner === Utils.getUserName(userId));
    },

    update: function(userId, doc, fieldNames, modifier) {
        return (doc.owner === Utils.getUserName(userId));
    },

    remove: function(userId, doc) {
        return (doc.owner === Utils.getUserName(userId));
    }
};

//
// NOTE: Prashant/Sachin, if you get a merge conflict here, please,
// when you edit leave the allow() calls next to the new calls, 
// otherwise I am prone to forget including them and spend too much
// time debugging.
// 

UserProfiles = new Mongo.Collection('UserProfiles');
UserProfiles.allow(userProfilePerms);

Albums = new Mongo.Collection('Albums');
Albums.allow(albumPerms);

HashChains = new Mongo.Collection('HashChains');
HashChains.allow(allAccessPerms);
HashChainNodes = new Mongo.Collection('HashChainNodes');
HashChainNodes.allow(allAccessPerms);

MerkleTrees = new Mongo.Collection('MerkleTrees');
MerkleTrees.allow(allAccessPerms);
MerkleTreeNodes = new Mongo.Collection('MerkleTreeNodes');
MerkleTreeNodes.allow(allAccessPerms);
MerkleTreeLeafIndex = new Mongo.Collection('MerkleTreeLeafIndex');
MerkleTreeLeafIndex.allow(allAccessPerms);

// FIXME: change these to check tree owner
AclTrees = new Mongo.Collection('AclTree');
AclTrees.allow(allAccessPerms);
AclNodes = new Mongo.Collection('AclNode');
AclNodes.allow(allAccessPerms);
AclIndexes = new Mongo.Collection('AclIndex');
AclIndexes.allow(allAccessPerms);

Dialogues = new Mongo.Collection('Dialogues');
Dialogues.allow(allAccessPerms);
Quacks = new Mongo.Collection('Quacks');
Quacks.allow(allAccessPerms);

UserConvos = new Mongo.Collection('UserConvos');
UserConvos.allow(allAccessPerms);
