TestConvos = {
  removeAllDialogues: function() {
    Dialogues.remove({});
    UserConvos.remove({});
    Quacks.remove({});
  },

  run: function() {
    TestAcls.removeAllAcls();
    TestUsers.removeAllUsers();
    TestConvos.removeAllDialogues();

    var users = [
      TestUsers.createUser('alinush'),

      TestUsers.createUser('javascript'),
      TestUsers.createUser('prashant'),

      TestUsers.createUser('james'),
    ];

    TestUsers.createFriendship(users[0], users[1]);
    TestUsers.createFriendship(users[0], users[2]);
    TestUsers.createFriendship(users[2], users[3]);
    TestUsers.createFriendship(users[2], users[1]);
    TestUsers.createFriendship(users[3], users[1]);

    TestWalls.setupWalls(users);

    var user1 = {
      username: users[1].username,
      publicKey: users[1].asymKeyPair,
      friendKey: TestUsers.getFriendKey(users[0], users[1]),
    };
    var user2 = {
      username: users[2].username,
      publicKey: users[2].asymKeyPair,
      friendKey: TestUsers.getFriendKey(users[0], users[2]),
    };
    var user3 = {
      username: users[3].username,
      publicKey: users[3].asymKeyPair,
      friendKey: TestUsers.getFriendKey(users[0], users[3]),
    };

    var c1 = TestConvos.startConvo(users[0], [ user1, user2 ], 'Check out my selfie!', 'Whaddaya think? Huh?');
    TestConvos.saySomething(c1, users[0], users[1], TestUsers.getFriendKey(users[0], users[1]),
      'Srsly bro?');
    TestConvos.saySomething(c1, users[0], users[2], TestUsers.getFriendKey(users[0], users[2]),
      'Weak dude. Weak.');
    TestConvos.saySomething(c1, users[0], users[0], users[0].masterKey,
      'You guys are HATIN\'!');

    var c2 = TestConvos.startConvo(users[1], [ {
      username: users[0].username,
      publicKey: users[0].asymKeyPair,
      friendKey: TestUsers.getFriendKey(users[0], users[1]),
    }, user3 ], 'OBAMA is EMPEROR!', 'How dare he give asylum?? HOW???');
    TestConvos.saySomething(c2, users[1], users[3], TestUsers.getFriendKey(users[3], users[1]),
      'RON PAUL 2016?');
    TestConvos.saySomething(c2, users[1], users[0], TestUsers.getFriendKey(users[0], users[1]),
      'COLBERT 2016!!!');
    
    for(var i = 0; i < users.length; i++) {
      var convoIds = Dialogue.getConversationIDs(users[i].username);
      console.log(users[i].username + ' convos: ' + stri(convoIds));
    }

    TestDemo.addPhotos(users);
  },
  
  startConvo: function(owner, withUsers, title, message) {
    var r = Dialogue.createConversation(owner.username, owner.masterKey, owner.asymKeyPair,
      withUsers, title);
    var dialogue = r.dialogue;
    var contentKey = r.contentKey;
    var convoId = dialogue.getObjectId();

    console.log('Convo ID: ' + convoId);

    dialogue.addQuack(Quack.create('message', owner.username, 1, message, dialogue), 
      contentKey, owner.asymKeyPair);

    return dialogue;
  },

  saySomething: function(convo, owner, sayer, friendKey, smth) {
    var acl = Acls.getAcl(convo.getObjectId(), owner.username, owner.asymKeyPair, 0);
    var aclVer = acl.acl.aclVer;
    var lastQuack = convo.getLastQuack();
    if(!lastQuack)
      lastQuack = convo;

    assert(aclVer > 0);

    var quack = Quack.create('message', sayer.username, aclVer, smth, lastQuack);
    var contentKeys = Acls.getContentKeys(convo.getObjectId(), owner.username, owner.asymKeyPair, 
      sayer.username, friendKey, acl.hash);

    convo.addQuack(quack, contentKeys[aclVer - 1], sayer.asymKeyPair);
    //console.log('Added convo quack: ' + quack.text);
  },
};
