TestWalls = {
  removeAllWalls: function() {
    Dialogues.remove({});
    Quacks.remove({});
  },

  run: function() {
    TestUsers.removeAllUsers();
    TestAcls.removeAllAcls();
    TestWalls.removeAllWalls();

    var users = [
      TestUsers.createUser('alinush'),

      TestUsers.createUser('javascript'),
      TestUsers.createUser('prashant'),

      TestUsers.createUser('james'),
    ];

    TestWalls.setupWalls(users);
  },
  
  setupWalls: function(users) {
    
    // JavaScript -> Alin
    var friendKey = TestUsers.getFriendKey(users[1], users[0]);
    TestWalls.saySomething(users[1], users[0], friendKey, 
      'Say something, I\'m giving up on you');
    TestWalls.saySomething(users[1], users[0], friendKey, 
      'Anywhere, I would\'ve followed you');
    TestWalls.saySomething(users[1], users[0], friendKey, 
      'I\'ll be the one, if you want me to');
    TestWalls.saySomething(users[1], users[0], friendKey, 
      'Say something, I\'m giving up on you...');

    // Alin
    TestWalls.saySomething(users[0], users[0], users[0].masterKey, 
      'I F***** HATE JAVASCRIPT');


    // Alin -> Prashant
    friendKey = TestUsers.getFriendKey(users[0], users[2]);
    TestWalls.saySomething(users[0], users[2], friendKey,
      'Kahin badal na jaana sanam');
    TestWalls.saySomething(users[0], users[2], friendKey, 
      'Badalke meri tum zindagaani');
    TestWalls.saySomething(users[0], users[2], friendKey, 
      'Nazar nahin churaana sanam');
    TestWalls.saySomething(users[0], users[2], friendKey,
      'Chura liya hai tumne jo dil ko');

    // Have james friend prashant and post a message on prashant's wall, check that alin can see it
    friendKey = TestUsers.getFriendKey(users[3], users[2]);
    TestWalls.saySomething(users[3], users[2], friendKey, 
      'DEATH TO JAVASCRIPT!!');

    // Everyone hate on javascript
    friendKey = TestUsers.getFriendKey(users[0], users[1]);
    TestWalls.saySomething(users[0], users[1], friendKey,
      'Why you gotta be so rude? Don\'t you know I\'m human too? Why you gotta be so rude? '
      + 'I\'M NEVER GONNA MARRY YOU ANYWAY!!!');
    friendKey = TestUsers.getFriendKey(users[2], users[1]);
    TestWalls.saySomething(users[2], users[1], friendKey,
      'Please don\'t go...');
    friendKey = TestUsers.getFriendKey(users[3], users[1]);
    TestWalls.saySomething(users[3], users[1], friendKey,
      'May the souls of your careless users rest in peace, for they are no longer a single piece.');

    var me = users[0];
    for(var i = 0; i < users.length; i++) {
      if(Friends.isMyFriend(me.username, users[i].username)) {
        var dialogue = Dialogue.getWall(users[i].username);
        var dialogueId = dialogue.getObjectId();

        var acl = Acls.getAcl(dialogueId, users[i].username, users[i].asymKeyPair, 0);
        var contentKeys = Acls.getContentKeys(dialogueId, users[i].username, 
          users[i].asymKeyPair, me.username, 
          TestUsers.getFriendKey(me, users[i]), acl.hash);

        // This call goes down from the last quack till he beginning of the dialogue and should 
        // return all the quacks in the dialogue
        var quacks = dialogue.getQuacks(me.username, me.masterKey, contentKeys, 
          dialogue.getLastQuack(), dialogue.hash());

        return quacks;
      }
    }
  },

  saySomething: function(sayer, listener, friendKey, smth) {
    var wall = Dialogue.getWall(listener.username);
    var wallId = wall.getObjectId();
    var acl = Acls.getAcl(wallId, listener.username, listener.asymKeyPair, 0);
    var aclVer = acl.acl.aclVer;
    var lastQuack = wall.getLastQuack();
    if(!lastQuack)
      lastQuack = wall;

    var quack = Quack.create('wallpost', sayer.username, aclVer, smth, lastQuack);
    var contentKeys = Acls.getContentKeys(wallId, listener.username, listener.asymKeyPair, 
      sayer.username, friendKey, acl.hash);

    wall.addQuack(quack, contentKeys[aclVer - 1], sayer.asymKeyPair);
    //console.log('Added quack: ' + quack.text);
  }
};
